#import "AppDelegate.h"

#import <React/RCTBundleURLProvider.h>
#import <MPushLibrary/MPushLibrary.h>

@implementation AppDelegate

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
  self.moduleName = @"ReactProject";
  // You can add your custom initial props in the dictionary below.
  // They will be passed down to the ViewController used by React Native.
  self.initialProps = @{};
  
  //PushManager 초기화 및 메시지를 전달
  [[PushManager defaultManager] application:application didFinishLaunchingWithOptions:launchOptions];
  
#ifdef DEBUG
  /* APNS_MODE설정을 위한 값(4.0이상)
   * 여러 위치 사용 가능 설명을 위해 PushReceiver.m 파일에도 샘플 코드가 있음 *
   - APNS_MODE는 서버에서 메시지 발송시 APNS서버를 TEST로 발송할지 REAL로 발송할지의 대한 여부값이 됨
   - RegisterService API호출시 서버에 해당값을 전달
   - PushManager 초기화시 값이 설정되며 default 값은 REAL
   - 개발용 인증서로 빌드시 APNS TOKEN값은 TEST토큰값이므로 DEV설정 필요
   */
  [[PushManager defaultManager].info changeMode:@"DEV"];
#endif
  
  return [super application:application didFinishLaunchingWithOptions:launchOptions];
}

- (NSURL *)sourceURLForBridge:(RCTBridge *)bridge
{
  return [self getBundleURL];
}

- (NSURL *)getBundleURL
{
#if DEBUG
  return [[RCTBundleURLProvider sharedSettings] jsBundleURLForBundleRoot:@"index"];
#else
  return [[NSBundle mainBundle] URLForResource:@"main" withExtension:@"jsbundle"];
#endif
}

@end
