package com.MPushPlugin.push;

import android.os.Handler;
import android.os.Message;
import android.text.TextUtils;
import android.util.Log;

import androidx.annotation.NonNull;

import com.MPushPlugin.MPushPlugin;
import com.facebook.react.bridge.Arguments;
import com.facebook.react.bridge.Callback;
import com.facebook.react.bridge.ReactContext;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.WritableMap;
import com.facebook.react.modules.core.DeviceEventManagerModule;

import org.json.JSONException;
import org.json.JSONObject;

import m.client.push.library.common.PushConstants;

public class PushUiHandler extends Handler {
    public static final int REG_PUSHSERVICE_COMPLETED = 0;
    public static final int REG_PUSHUSER_COMPLETELED = 1;
    public static final int GET_PUSHMESSAGES_COMPLETELED = 2;
    public static final int UNREG_PUSHSERVICE_COMPLETED = 3;
    public static final int SEND_MESSAGE_COMPLETED = 4;
    public static final int REG_SERVICEANDUSER_COMPLETED = 5;
    public static final int REG_GROUP_COMPLETED = 6;
    public static final int UNREG_GROUP_COMPLETED = 7;
    public static final int INIT_BADGE_COMPLETED = 8;
    public static final int READ_MESSAGE_COMPLETED = 9;
    public static final int UNREG_PUSHUSER_COMPLETED = 10;

    @ReactMethod
    public void addListener(String eventName) {

    }

    @ReactMethod
    public void removeListeners(Integer count) {

    }
    public static com.facebook.react.bridge.Callback callback1;
    public static void setCallback(com.facebook.react.bridge.Callback callback){
        callback1 = callback;
    }
    static com.facebook.react.bridge.Callback getCallback(){
        return callback1;
    }

    private void sendEvent(ReactContext reactContext, String eventName, String params) {
        reactContext.getJSModule(DeviceEventManagerModule.RCTDeviceEventEmitter.class).emit(eventName, params);
    }

    @Override
    public void handleMessage(Message msg) {
        super.handleMessage(msg);


        switch (msg.what) {
            case REG_PUSHSERVICE_COMPLETED:
                try {
                    final String regPushServiceResult = (String) msg.obj;
                    Log.d("PushUiHandler", "REG_PUSHSERVICE_COMPLETED RESULT:: " + regPushServiceResult);
                    final JSONObject jsonObj = new JSONObject(regPushServiceResult);
                    String resultCode = jsonObj.getString(PushConstants.KEY_RESULT_CODE);
                    String resultMessage = jsonObj.getString(PushConstants.KEY_RESULT_MSG);
                    final String isRegister = (jsonObj.has(PushConstants.KEY_ISREGISTER)) ? jsonObj.getString(PushConstants.KEY_ISREGISTER) : "";
                    if (!TextUtils.isEmpty(isRegister)) {
                        if (isRegister.equals("C")) {
                            resultMessage = "사용자 재등록 필요";
                            resultCode = PushConstants.RESULTCODE_OK;
                        } else if (isRegister.equals("N")) {
                            resultMessage = "서비스 재등록 필요";
                        }
                    }

                    final String fResultCode = resultCode;
                    final String fResultMessage = resultMessage;

                    try {
                        JSONObject returnValue = new JSONObject();
                        String status = (PushConstants.RESULTCODE_OK.equals(fResultCode)) ? "SUCCESS" : "FAIL";
                        returnValue.put("status", status);
                        returnValue.put("isRegister", isRegister);
                        if ("FAIL".equals(status)) {
                            returnValue.put("error", fResultMessage);
                        }
//                        WritableMap params = Arguments.createMap();
//                        params.putString("eventProperty", String.valueOf(returnValue));
                        if (getCallback() != null) {
                            Log.e("getcallback::", getCallback().toString());
                            getCallback().invoke(String.valueOf(returnValue));
                            setCallback(null);
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }


                } catch (Exception e1) {
                    e1.printStackTrace();
                }
                break;

            case UNREG_PUSHSERVICE_COMPLETED:
                try {
                    final String unregPushServiceResult = (String) msg.obj;
                    Log.d("PushUiHandler", "UNREG_PUSHSERVICE_COMPLETED RESULT:: " + unregPushServiceResult);
                    final JSONObject jsonObj = new JSONObject(unregPushServiceResult);
                    final String resultCode = jsonObj.getString(PushConstants.KEY_RESULT_CODE);
                    final String resultMessage = jsonObj.getString(PushConstants.KEY_RESULT_MSG);


                    try {
                        JSONObject returnValue = new JSONObject();
                        String status = (PushConstants.RESULTCODE_OK.equals(resultCode)) ? "SUCCESS" : "FAIL";
                        returnValue.put("status", status);
                        if ("FAIL".equals(status)) {
                            returnValue.put("error", resultMessage);
                        }
                        //sendEvent(MPushPlugin.mReactContext,"unRegisterService",String.valueOf(returnValue));
                        if (getCallback() != null) {
                            Log.e("getcallback::", getCallback().toString());
                            getCallback().invoke(String.valueOf(returnValue));
                            setCallback(null);
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }


                } catch (Exception e1) {
                    e1.printStackTrace();
                }
                break;

            case SEND_MESSAGE_COMPLETED:
                try {
                    final String sendMessageResult = (String) msg.obj;
                    Log.d("PushUiHandler", "SEND_MESSAGE_COMPLETED RESULT:: " + sendMessageResult);
                    final JSONObject jsonObj = new JSONObject(sendMessageResult);
                    final String resultCode = jsonObj.getString(PushConstants.KEY_RESULT_CODE);
                    final String resultMessage = jsonObj.getString(PushConstants.KEY_RESULT_MSG);

                    try {
                        JSONObject returnValue = new JSONObject();
                        String status = (PushConstants.RESULTCODE_OK.equals(resultCode)) ? "SUCCESS" : "FAIL";
                        returnValue.put("status", status);
                        returnValue.put("result", jsonObj.optString("RESULT_BODY"));
                        if ("FAIL".equals(status)) {
                            returnValue.put("error", resultMessage);
                        }
                        Log.d("SEND MESSAGE", jsonObj.optString("RESULT_BODY"));

                    } catch (JSONException e) {
                        e.printStackTrace();
                    }


                } catch (Exception e1) {
                    e1.printStackTrace();
                }
                break;

            case REG_SERVICEANDUSER_COMPLETED:
                try {
                    final String regServiceAndUserResult = (String) msg.obj;
                    Log.d("PushUiHandler", "REG_SERVICEANDUSER_COMPLETED RESULT:: " + regServiceAndUserResult);
                    final JSONObject jsonObj = new JSONObject(regServiceAndUserResult);
                    final String resultCode = jsonObj.getString(PushConstants.KEY_RESULT_CODE);
                    final String resultMessage = jsonObj.getString(PushConstants.KEY_RESULT_MSG);


                    try {
                        JSONObject returnValue = new JSONObject();
                        String status = (PushConstants.RESULTCODE_OK.equals(resultCode)) ? "SUCCESS" : "FAIL";
                        returnValue.put("status", status);
                        if ("FAIL".equals(status)) {
                            returnValue.put("error", resultMessage);
                        }

                        //sendEvent(MPushPlugin.mReactContext,"registerServiceAndUser",String.valueOf(returnValue));
                        if (getCallback() != null) {
                            Log.e("getcallback::", getCallback().toString());
                            getCallback().invoke(String.valueOf(returnValue));
                            setCallback(null);
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }


                } catch (Exception e1) {
                    e1.printStackTrace();
                }
                break;

            case REG_PUSHUSER_COMPLETELED:
                try {
                    final String regPushUserResult = (String) msg.obj;
                    Log.d("PushUiHandler", "REG_PUSHUSER_COMPLETELED RESULT:: " + regPushUserResult);
                    final JSONObject jsonObj = new JSONObject(regPushUserResult);
                    final String resultCode = jsonObj.getString(PushConstants.KEY_RESULT_CODE);
                    final String resultMessage = jsonObj.getString(PushConstants.KEY_RESULT_MSG);

                    try {
                        JSONObject returnValue = new JSONObject();
                        String status = (PushConstants.RESULTCODE_OK.equals(resultCode)) ? "SUCCESS" : "FAIL";
                        returnValue.put("status", status);
                        if ("FAIL".equals(status)) {
                            returnValue.put("error", resultMessage);
                        }
                        if (getCallback() != null) {
                            Log.e("getcallback::", getCallback().toString());
                            getCallback().invoke(String.valueOf(returnValue));
                            setCallback(null);
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }


                } catch (Exception e1) {
                    e1.printStackTrace();
                }
                break;

            case REG_GROUP_COMPLETED:
                try {
                    final String regPushUserResult = (String) msg.obj;
                    Log.d("PushUiHandler", "REG_GROUP_COMPLETED RESULT:: " + regPushUserResult);
                    final JSONObject jsonObj = new JSONObject(regPushUserResult);
                    final String resultCode = jsonObj.getString(PushConstants.KEY_RESULT_CODE);
                    final String body = jsonObj.getString(PushConstants.KEY_BODY);
                    final String resultMessage = jsonObj.getString(PushConstants.KEY_RESULT_MSG);


                    try {
                        JSONObject returnValue = new JSONObject();
                        String status = (PushConstants.RESULTCODE_OK.equals(resultCode)) ? "SUCCESS" : "FAIL";
                        returnValue.put("status", status);
                        if ("FAIL".equals(status)) {
                            returnValue.put("error", resultMessage);
                        }else{
                            returnValue.put("body",body);
                        }
                        if (getCallback() != null) {
                            Log.e("getcallback::", getCallback().toString());
                            getCallback().invoke(String.valueOf(returnValue));
                            setCallback(null);
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                } catch (Exception e1) {
                    e1.printStackTrace();
                }
                break;

            case UNREG_GROUP_COMPLETED:
                try {
                    final String regPushUserResult = (String) msg.obj;
                    Log.d("PushUiHandler", "UNREG_GROUP_COMPLETED RESULT:: " + regPushUserResult);
                    final JSONObject jsonObj = new JSONObject(regPushUserResult);
                    final String resultCode = jsonObj.getString(PushConstants.KEY_RESULT_CODE);
                    final String body = jsonObj.getString(PushConstants.KEY_BODY);
                    final String resultMessage = jsonObj.getString(PushConstants.KEY_RESULT_MSG);


                    try {
                        JSONObject returnValue = new JSONObject();
                        String status = (PushConstants.RESULTCODE_OK.equals(resultCode)) ? "SUCCESS" : "FAIL";
                        returnValue.put("status", status);
                        if ("FAIL".equals(status)) {
                            returnValue.put("error", resultMessage);
                        }else{
                            returnValue.put("body", body);
                        }
                        if (getCallback() != null) {
                            Log.e("getcallback::", getCallback().toString());
                            getCallback().invoke(String.valueOf(returnValue));
                            setCallback(null);
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }


                } catch (Exception e1) {
                    e1.printStackTrace();
                }
                break;

            case INIT_BADGE_COMPLETED:
                try {
                    final String regPushUserResult = (String) msg.obj;
                    Log.d("PushUiHandler", "INIT_BADGE_COMPLETED RESULT:: " + regPushUserResult);
                    final JSONObject jsonObj = new JSONObject(regPushUserResult);
                    final String resultCode = jsonObj.getString(PushConstants.KEY_RESULT_CODE);
                    final String resultMessage = jsonObj.getString(PushConstants.KEY_RESULT_MSG);


                    try {
                        JSONObject returnValue = new JSONObject();
                        String status = (PushConstants.RESULTCODE_OK.equals(resultCode)) ? "SUCCESS" : "FAIL";
                        returnValue.put("status", status);
                        if ("FAIL".equals(status)) {
                            returnValue.put("error", resultMessage);
                        }
                        if (getCallback() != null) {
                            Log.e("getcallback::", getCallback().toString());
                            getCallback().invoke(String.valueOf(returnValue));
                            setCallback(null);
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }


                } catch (Exception e1) {
                    e1.printStackTrace();
                }
                break;

            case READ_MESSAGE_COMPLETED:
                try {
                    final String regPushUserResult = (String) msg.obj;
                    Log.d("PushUiHandler", "READ_MESSAGE_COMPLETED RESULT:: " + regPushUserResult);
                    final JSONObject jsonObj = new JSONObject(regPushUserResult);
                    final String resultCode = jsonObj.getString(PushConstants.KEY_RESULT_CODE);
                    final String resultMessage = jsonObj.getString(PushConstants.KEY_RESULT_MSG);

                    try {
                        JSONObject returnValue = new JSONObject();
                        String status = (PushConstants.RESULTCODE_OK.equals(resultCode)) ? "SUCCESS" : "FAIL";
                        returnValue.put("status", status);
                        if ("FAIL".equals(status)) {
                            returnValue.put("error", resultMessage);
                        }
                        if (getCallback() != null) {
                            Log.e("getcallback::", getCallback().toString());
                            getCallback().invoke(String.valueOf(returnValue));
                            setCallback(null);
                        }
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                } catch (Exception e1) {
                    e1.printStackTrace();
                }
                break;

            case UNREG_PUSHUSER_COMPLETED:
                try {
                    final String unregMsg = (String) msg.obj;
                    Log.d("PushUiHandler", "UNREG_PUSHUSER RESULT:: " + unregMsg);
                    final JSONObject jsonObj = new JSONObject(unregMsg);
                    final String resultCode = jsonObj.getString(PushConstants.KEY_RESULT_CODE);
                    final String resultMessage = jsonObj.getString(PushConstants.KEY_RESULT_MSG);

                    try {
                        JSONObject returnValue = new JSONObject();
                        String status = (PushConstants.RESULTCODE_OK.equals(resultCode)) ? "SUCCESS" : "FAIL";
                        returnValue.put("status", status);
                        if ("FAIL".equals(status)) {
                            returnValue.put("error", resultMessage);
                        }
                        if (getCallback() != null) {
                            Log.e("getcallback::", getCallback().toString());
                            getCallback().invoke(String.valueOf(returnValue));
                            setCallback(null);
                        }

                    } catch (JSONException e) {
                        e.printStackTrace();
                    }


                } catch (Exception e1) {
                    e1.printStackTrace();
                }
                break;

            default:
                Log.d("PushUiHandler", "UNKNOWN MESSAGE:: " + msg.what);
                break;
        }
    }
}
