package com.MPushPlugin.receiver;

import android.content.Intent;
import android.content.pm.PackageManager;
import android.util.Log;

import com.google.firebase.messaging.FirebaseMessagingService;
import com.google.firebase.messaging.RemoteMessage;

import m.client.push.library.PushMessagingManager;
import m.client.push.library.common.Logger;
import m.client.push.library.service.FCMIntentService;
import m.client.push.library.utils.PushUtils;

public class CustomMessagingService extends FCMIntentService {
	@Override
	public void onNewToken(String s) {
		super.onNewToken(s);
		PushMessagingManager.getInstance().newToken(getApplicationContext());
	}

	@Override
	public void onMessageReceived(RemoteMessage remoteMessage) {
		super.onMessageReceived(remoteMessage);
		PackageManager packageManager = getPackageManager();
		Intent intent1 = packageManager.getLaunchIntentForPackage(getApplicationContext().getPackageName());
		intent1.addFlags(Intent.FLAG_ACTIVITY_CLEAR_TOP | Intent.FLAG_ACTIVITY_SINGLE_TOP);

		intent1.putExtra("pushData", remoteMessage.getData().toString());

		Log.d("RemoteMessage_Log",remoteMessage.getData().toString());
		if(PushUtils.isMPush(remoteMessage)) {
			Logger.e(remoteMessage.toString());
			PushMessagingManager.getInstance().messageReceived(getApplicationContext(), remoteMessage);
		}
		else{
			//ARS 푸시 처리
		}
	}

}
